
/* This is passed through the C preprocessor to make another header file 
 * 
 * $Log$
 */
#define MAKE_INST_FOR_REG(name, reg) \#define name##_##reg  (name + reg)

/* push instructions */
#define PUSH	0x50

MAKE_INST_FOR_REG(PUSH, AX)
MAKE_INST_FOR_REG(PUSH, BX)
MAKE_INST_FOR_REG(PUSH, CX)
MAKE_INST_FOR_REG(PUSH, DX)
MAKE_INST_FOR_REG(PUSH, DI)
MAKE_INST_FOR_REG(PUSH, SI)
MAKE_INST_FOR_REG(PUSH, BP)
MAKE_INST_FOR_REG(PUSH, SP)

#undef PUSH
#define PUSH 0x6
MAKE_INST_FOR_REG(PUSH, CS)
MAKE_INST_FOR_REG(PUSH, SS)
MAKE_INST_FOR_REG(PUSH, ES)
MAKE_INST_FOR_REG(PUSH, DS)
#undef PUSH

/* pop instructions */
#define POP 0x58
MAKE_INST_FOR_REG(POP, SP)
MAKE_INST_FOR_REG(POP, AX)
MAKE_INST_FOR_REG(POP, BX)
MAKE_INST_FOR_REG(POP, CX)
MAKE_INST_FOR_REG(POP, DX)
MAKE_INST_FOR_REG(POP, DI)
MAKE_INST_FOR_REG(POP, SI)
MAKE_INST_FOR_REG(POP, BP)
#undef POP
#define POP 0x7
MAKE_INST_FOR_REG(POP, DS)
MAKE_INST_FOR_REG(POP, SS)
MAKE_INST_FOR_REG(POP, ES)
#undef POP

#define INC  0x40
MAKE_INST_FOR_REG(INC, AX)
MAKE_INST_FOR_REG(INC, BX)
MAKE_INST_FOR_REG(INC, CX)
MAKE_INST_FOR_REG(INC, DX)
MAKE_INST_FOR_REG(INC, DI)
MAKE_INST_FOR_REG(INC, SI)
MAKE_INST_FOR_REG(INC, BP)
MAKE_INST_FOR_REG(INC, SP)
#undef INC

#define DEC  0x48
MAKE_INST_FOR_REG(DEC, AX)
MAKE_INST_FOR_REG(DEC, BX)
MAKE_INST_FOR_REG(DEC, CX)
MAKE_INST_FOR_REG(DEC, DX)
MAKE_INST_FOR_REG(DEC, DI)
MAKE_INST_FOR_REG(DEC, SI)
MAKE_INST_FOR_REG(DEC, BP)
MAKE_INST_FOR_REG(DEC, SP)
#undef DEC

#define SEG_OVERRIDE 0x26
MAKE_INST_FOR_REG(SEG_OVERRIDE, ES)
MAKE_INST_FOR_REG(SEG_OVERRIDE, DS)
MAKE_INST_FOR_REG(SEG_OVERRIDE, CS)
MAKE_INST_FOR_REG(SEG_OVERRIDE, SS)
#undef SEG_OVERRIDE

#ifdef XCHG
#error XCHG multiply defined
#endif

#define XCHG 0x90
#if 0
/* this is also the nop MAKE_INST_FOR_REG(XCHG, AX) */
#endif
MAKE_INST_FOR_REG(XCHG, BX)
MAKE_INST_FOR_REG(XCHG, CX)
MAKE_INST_FOR_REG(XCHG, DX)
MAKE_INST_FOR_REG(XCHG, SI)
MAKE_INST_FOR_REG(XCHG, DI)
MAKE_INST_FOR_REG(XCHG, BP)
MAKE_INST_FOR_REG(XCHG, SP )
#undef XCHG

/* move word registers */
#define MOV 0xB8
MAKE_INST_FOR_REG(MOV, AX)
MAKE_INST_FOR_REG(MOV, BX)
MAKE_INST_FOR_REG(MOV, CX)
MAKE_INST_FOR_REG(MOV, DX)
MAKE_INST_FOR_REG(MOV, SI)
MAKE_INST_FOR_REG(MOV, DI)
MAKE_INST_FOR_REG(MOV, BP)
MAKE_INST_FOR_REG(MOV, SP )
#undef MOV


/* move byte registers */
#define MOV  0xb0
MAKE_INST_FOR_REG(MOV, AL)
MAKE_INST_FOR_REG(MOV, AH)
MAKE_INST_FOR_REG(MOV, BL)
MAKE_INST_FOR_REG(MOV, BH)
MAKE_INST_FOR_REG(MOV, CL)
MAKE_INST_FOR_REG(MOV, CH)
MAKE_INST_FOR_REG(MOV, DL)
MAKE_INST_FOR_REG(MOV, DH)
#undef MOV

