# 1 "8086opcodes.cpp"

/* This is passed through the C preprocessor to make another header file 
 * 
 * $Log$
 */


/* push instructions */


#define  PUSH_AX   ( 0x50   +   AX ) 
#define  PUSH_BX   ( 0x50   +   BX ) 
#define  PUSH_CX   ( 0x50   +   CX ) 
#define  PUSH_DX   ( 0x50   +   DX ) 
#define  PUSH_DI   ( 0x50   +   DI ) 
#define  PUSH_SI   ( 0x50   +   SI ) 
#define  PUSH_BP   ( 0x50   +   BP ) 
#define  PUSH_SP   ( 0x50   +   SP ) 



#define  PUSH_CS   ( 0x6   +   CS ) 
#define  PUSH_SS   ( 0x6   +   SS ) 
#define  PUSH_ES   ( 0x6   +   ES ) 
#define  PUSH_DS   ( 0x6   +   DS ) 


/* pop instructions */

#define  POP_SP   ( 0x58   +   SP ) 
#define  POP_AX   ( 0x58   +   AX ) 
#define  POP_BX   ( 0x58   +   BX ) 
#define  POP_CX   ( 0x58   +   CX ) 
#define  POP_DX   ( 0x58   +   DX ) 
#define  POP_DI   ( 0x58   +   DI ) 
#define  POP_SI   ( 0x58   +   SI ) 
#define  POP_BP   ( 0x58   +   BP ) 


#define  POP_DS   ( 0x7   +   DS ) 
#define  POP_SS   ( 0x7   +   SS ) 
#define  POP_ES   ( 0x7   +   ES ) 



#define  INC_AX   (  0x40   +   AX ) 
#define  INC_BX   (  0x40   +   BX ) 
#define  INC_CX   (  0x40   +   CX ) 
#define  INC_DX   (  0x40   +   DX ) 
#define  INC_DI   (  0x40   +   DI ) 
#define  INC_SI   (  0x40   +   SI ) 
#define  INC_BP   (  0x40   +   BP ) 
#define  INC_SP   (  0x40   +   SP ) 



#define  DEC_AX   (  0x48   +   AX ) 
#define  DEC_BX   (  0x48   +   BX ) 
#define  DEC_CX   (  0x48   +   CX ) 
#define  DEC_DX   (  0x48   +   DX ) 
#define  DEC_DI   (  0x48   +   DI ) 
#define  DEC_SI   (  0x48   +   SI ) 
#define  DEC_BP   (  0x48   +   BP ) 
#define  DEC_SP   (  0x48   +   SP ) 



#define  SEG_OVERRIDE_ES   ( 0x26   +   ES ) 
#define  SEG_OVERRIDE_DS   ( 0x26   +   DS ) 
#define  SEG_OVERRIDE_CS   ( 0x26   +   CS ) 
#define  SEG_OVERRIDE_SS   ( 0x26   +   SS ) 










#define  XCHG_BX   ( 0x90   +   BX ) 
#define  XCHG_CX   ( 0x90   +   CX ) 
#define  XCHG_DX   ( 0x90   +   DX ) 
#define  XCHG_SI   ( 0x90   +   SI ) 
#define  XCHG_DI   ( 0x90   +   DI ) 
#define  XCHG_BP   ( 0x90   +   BP ) 
#define  XCHG_SP    ( 0x90   +   SP  ) 


/* move word registers */

#define  MOV_AX   ( 0xB8   +   AX ) 
#define  MOV_BX   ( 0xB8   +   BX ) 
#define  MOV_CX   ( 0xB8   +   CX ) 
#define  MOV_DX   ( 0xB8   +   DX ) 
#define  MOV_SI   ( 0xB8   +   SI ) 
#define  MOV_DI   ( 0xB8   +   DI ) 
#define  MOV_BP   ( 0xB8   +   BP ) 
#define  MOV_SP    ( 0xB8   +   SP  ) 



/* move byte registers */

#define  MOV_AL   (  0xb0   +   AL ) 
#define  MOV_AH   (  0xb0   +   AH ) 
#define  MOV_BL   (  0xb0   +   BL ) 
#define  MOV_BH   (  0xb0   +   BH ) 
#define  MOV_CL   (  0xb0   +   CL ) 
#define  MOV_CH   (  0xb0   +   CH ) 
#define  MOV_DL   (  0xb0   +   DL ) 
#define  MOV_DH   (  0xb0   +   DH ) 


