/* dosboot.c */
BOOLEAN boot_msdos(char *first_task_name, const char *command_line);
/* dosmisc.c */
void set_dos_date(void);
void dos_extended_country_info(void);
void dos_country_info(void);
void dos_internal_server_function(void);
void dos_extended_break_checking(void);
void get_stdin_status(void);
void write_character_to_stdout(void);
int get_extended_error_info(void);
void get_dos_free_disk_space(void);
void get_current_default_drive(void);
void dos_select_default_drive(void);
void dos_getcwd(void);
void dos_chdir(void);
void dos_set_dta_address(void);
void dos_get_dta_address(void);
/* dosemu.c */
void dos_messages(char *fmt, ...);
void trace_dos_call(void);
BYTE *convert_far_pointer(BYTE *p);
void dos_get_interrupt_vector(void);
void bad_interrupt(const int interrupt_number);
void set_pc_interrupt(int number, WORD segment, WORD offset);
void set_bad_interrupt(int number);
void dos_set_interrupt_vector(void);
void emulate_int21(void);
/* dostasks.c */
BOOLEAN load_first_task(const char *name, MEM_BLOCK *penvironment, const char *command_line);
void dos_exec(void);
void process_exit(void);
void get_process_return_code(void);
void get_current_psp(void);
void set_current_psp(void);
void create_child_psp(void);
/* dosmem.c */
void make_arena_header(MEM_BLOCK *pmem, WORD owner);
void show_dos_mem_trace(char *fmt, ...);
MEM_BLOCK *find_mem_block(const WORD segment);
void add_to_dos_list(MEM_BLOCK *p);
MEM_BLOCK *get_biggest_free_block(void);
MEM_BLOCK *get_block(int clicks);
void dos_get_block(void);
void dos_free_block(void);
void do_resize_block(void);
void remove_task_blocks(TASK *ptask);
MEM_BLOCK *make_environment(char *environment);
void boot_memory(void);
/* dosio.c */
char *get_drive_path_for_unix(const unsigned drive);
void append_unix_name_to_current_drive(const char *name);
char *dos_getcwd_on_specific_drive(const int drive);
void initialize_handles_for_first_task(const TASK *first_task);
void do_ioctl(void);
void do_lseek(void);
void do_write(void);
void do_read(void);
void do_open(void);
void do_close(void);
void do_create(void);
void dos_unlink_asciiz(void);
void boot_filesystems(void);
void remove_task_handles(TASK *ptask);
char *find_first_directory(char *string);
void standard_write_string(void);
void dos_canonicalize_filename(void);
void dos_buffered_input(void);
char *fix_directory(const char *name);
void dos_get_file_date_and_time(void);
void dos_chmod(void);
void dos_dup(void);
void dos_dup2(void);
void inherit_file_table(TASK *child, TASK *parent);
char *convert_dos_asciiz_to_unix_name(char *asciiz);
/* dostime.c */
void get_dos_date(void);
void get_dos_time(void);
/* dos_cvt_time.c */
DOUBLE_WORD convert_unix_time(time_t t);
/* dossearch.c */
void dos_find_first_file(void);
void dos_find_next_file(void);
/* dosfcb.c */
void fcb_parse_filename(void);
void dos_fcb_findfirst(void);
void dos_fcb_close(void);
void dos_fcb_findnext(void);
/* unixmagic.c */
void unix_magic(void);
/* vidbios.c */
void vid_bios_interrupt(void);
/* keyboard.c */
void keyboard_bios_interrupt(void);
