/* 
 *
 * $Log$
 */

#include <stdio.h>
#include <time.h>

#include "misc.h"
#include "8086regs.h"


static struct tm *get_current_time()
{
	time_t clock;

	time(&clock);
	return localtime(&clock);
}

	 
/*
 * INT 21 - DOS 1+ - GET SYSTEM DATE
 *         AH = 2Ah
 * Return: CX = year (1980-2099)
 *         DH = month
 *         DL = day
 * 
 */
void get_dos_date(void)
{
        struct tm current_time;

	current_time = *get_current_time(); 
	regs.cx = current_time.tm_year  + 1900 ;
	regs.dh = current_time.tm_mon + 1; /*? */
	regs.dl = current_time.tm_mday;
}

/*
 * 
 * INT 21 - DOS 1+ - GET SYSTEM TIME
        AH = 2Ch
Return: CH = hour
        CL = minute
        DH = second
        DL = 1/100 seconds
Note:   on most systems, the resolution of the system clock is about 5/100sec,
          so returned times generally do not increment by 1
        on some systems, DL may always return 00h
SeeAlso: AH=2Ah,AH=2Dh,AH=E7h,INT 1A/AH=00h,INT 1A/AH=02h,INT 1A/AH=FEh
SeeAlso: INT 2F/AX=120Dh
 */
void get_dos_time(void)
{
        struct tm current_time;

        current_time = *get_current_time();
	
	regs.ch = current_time.tm_hour;
	regs.cl = current_time.tm_min;
	regs.dh = current_time.tm_sec;
	regs.dl = 0;   /* this should be better latter */
}



