#include <stdio.h>

#define USE_ABORT
#ifdef USE_ABORT
void abort(void);


void (*assert_failed)(void) = abort;
#else
/* to override assert failure strategy */
void (*assert_failed)(void) = NULL;

#endif

/* assert with a function name */
void func_assert(const char *file, int line, const char *function,
                int assertion, const char *assertion_string)
{
        if(!assertion) {
                fprintf(stderr, "Assertion failed %s at file: %s line: %d, function %s\n",
                        assertion_string, file, line, function);
                if(assert_failed)
                        (*assert_failed)();
        }
}

