
#ifndef _MISC_H
#define _MISC_H


#ifdef MAIN

#ifndef EXTERN
#define EXTERN
#endif
#ifndef INIT
#define INIT(x) = x
#endif

#else

#ifndef EXTERN
#define EXTERN extern
#endif

#ifndef INIT
#define INIT(x)
#endif

#endif

typedef enum { TRUE = 1, FALSE = 0 } BOOLEAN;

#ifndef 0
#define fatal_error()		{ fprintf(stderr, "Fatal error at %d in " __FILE__ ": compiled " \
				__DATE__ " " __TIME__ "\n", __LINE__ ); \
				 print_saved_instructions(); \
				 abort();  }
#else
#define fatal_error()
#endif

#ifndef assert
extern void func_assert(const char *file, const int line, const char *function,
                const int condition, const char *con_string);
#define assert(p)       func_assert(__FILE__, __LINE__, __FUNCTION__, (int) (p), #p)
#endif

#define COMPILED_AT  "$I" "d: " __FILE__ " compiled at " __DATE__ " " __TIME__ " $" 

#define DOSLOG(p)		puts(__FUNCTION__ p);


#ifdef DEBUG
 
#ifndef TEST_MAGIC
#define TEST_MAGIC(x)    { assert(x); assert(x->magic == x); }
#endif
 
#ifndef MAKE_MAGIC
#define MAKE_MAGIC(x)   (x->magic = x)
#endif

#ifndef CLEAN_MAGIC
#define CLEAR_MAGIC(x)	(x->magic = NULL)
#endif
 
#else
#define MAKE_MAGIC(x)
#define TEST_MAGIC(x)
#define CLEAR_MAGIC(x)
#endif

/* dos environment -- initially nothing */
EXTERN char *dos_environment INIT(NULL);

/* debug flags */
EXTERN BOOLEAN dos_show_io INIT(FALSE);
#endif

