/* ANSI like strerror(3) routine */
#include <stdio.h>
#include <string.h>


/* Return a string descibing the errno code in ERRNUM.
   The storage is good only until the next call to strerror.
   Writing to the storage causes undefined behavior.  */
char *strerror(int errnum)
{
	extern int sys_nerr;
	extern char *sys_errlist[];

	if(errnum <  0 || errnum > sys_nerr) {
#define UNKNOWN "Unknown Error "
		/* template to write to */
		static char unknown_error[] = UNKNOWN  " 0000000";

		sprintf(unknown_error,  UNKNOWN " %d", errnum);
		return unknown_error;
	}

	return (char *) sys_errlist[errnum];
}


#ifdef TEST
main(int argc, char **argv)
{
	int i;

	if (argc <= 1) {
		fprintf(stderr, "Usage: %s errnums\n", argv[0]);
		exit(1);
	}	

	for(i = 1; i < argc; i++) {
		int error;

		error = atoi(argv[i]);
		printf("%d : %s\n",  error, strerror(error));
	}
}
#endif
