/*
 * This is support for the video bios (Interrupt 0x10)
 *
 * Copyright (C) 1993 Martin Leisner   leisner@eso.mc.xerox.com
 *      This program is free software; you can redistribute it and/or
 *      modify it under the terms of the GNU General Public License
 *      as published by the Free Software Foundation; either version 2
 *      of the License, or (at your option) any later version.
 * 
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 * 
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 * $Log$
 */

static const char rcsid[] = "$Id$";

#include <stdio.h>
#include "misc.h"
#include "8086regs.h"

static void function_12()
{
}
/*
INT 10 - VIDEO - SET CURSOR POSITION
        AH = 02h
        BH = page number
            0-3 in modes 2&3
            0-7 in modes 0&1
            0 in graphics modes
        DH = row (00h is top)
        DL = column (00h is left)

*/
static void function_2(void)
{
}

/*
INT 10 - VIDEO - GET CURSOR POSITION AND SIZE
        AH = 03h
        BH = page number
            0-3 in modes 2&3
            0-7 in modes 0&1
            0 in graphics modes
Return: AX = 0000h (Phoenix BIOS)
        CH = start scan line
        CL = end scan line
        DH = row (00h is top)
        DL = column (00h is left)
Notes:  a separate cursor is maintained for each of up to 8 display pages
        many ROM BIOSes incorrectly return the default size for a color display
          (start 06h, end 07h) when a monochrome display is attached
*/
static void function_3(void)
{
	regs.ch = 0;
	regs.dh = 0;	
}


void vid_bios_interrupt(void) 
{
	printf(__FUNCTION__ "with regs.ah = %x\n", regs.ah);
	switch(regs.ah) {
		case 0x12: 	function_12(); break;
		case 0x2:	function_2();	break;
		case 0x3:	function_3();	break;
	}
}


